#include<iostream>
using namespace std;
long long funk(int a){
	long long rez=0;
	for(long long i=1; i<a+1; i++){
		if(a%i==0){
			rez=rez^i;
		}
	}
	return rez;
}
int main() {
	long long n,k;
	cin>>n>>k;
	long long a;
	for(long long i=0; i<k; i++){
		cin>>a;
		cout<<funk(a)<<" ";
	}
	return 0;
}